## beancount 2.2.0

=== Makefile ===
#!/usr/bin/env make

# Just my big old fat ledger file.
INPUT = $(HOME)/q/office/accounting/blais.beancount
DOWNLOADS = $(HOME)/u/Downloads

GREP="grep --include="*.py" -srnE"
TOOLS=./tools

PYTHON?=python3

all: build


# Clean everything up.
clean:
	rm -f core
	rm -rf build
	rm -f $(CROOT)/grammar.h $(CROOT)/grammar.c
	rm -f $(CROOT)/lexer.h $(CROOT)/lexer.c
	rm -f $(CROOT)/*.so
	find . -name __pycache__ -exec rm -r "{}" \; -prune


# Targets to generate and compile the C parser.
CROOT = beancount/parser

# See
# https://www.owlfolio.org/possibly-useful/flex-input-scanner-rules-are-too-complicated/
#LEX = flex -Ca
LEX = flex

YACC = bison --report=itemset --verbose
FILTERYACC = sed -e 's@/\*[ \t]yacc\.c:.*\*/@@'
TMP=/tmp

$(CROOT)/grammar.c $(CROOT)/grammar.h: $(CROOT)/grammar.y
	$(YACC) -o $(CROOT)/grammar.c $<
	(cat $(CROOT)/grammar.c | $(FILTERYACC) > $(TMP)/grammar.c ; mv $(TMP)/grammar.c $(CROOT)/grammar.c )
	(cat $(CROOT)/grammar.h | $(FILTERYACC) > $(TMP)/grammar.h ; mv $(TMP)/grammar.h $(CROOT)/grammar.h )

UNICODE_CATEGORY_RANGES_GENERATOR=$(TOOLS)/generate_unicode_category_regexps.py
UNICODE_CATEGORY_DIR = $(CROOT)/lexer
UNICODE_CATEGORIES = Lu Ll Lt Lo Nd Nl No
UNICODE_CATEGORY_SOURCES = $(patsubst %, $(UNICODE_CATEGORY_DIR)/%.l, $(UNICODE_CATEGORIES))
$(UNICODE_CATEGORY_SOURCES): $(UNICODE_CATEGORY_DIR)/%.l :
	$(PYTHON) $(UNICODE_CATEGORY_RANGES_GENERATOR) \
		--format=lex --name=UTF-8-$* --categories=$* >$@

# Note that flex parses the files in the given order.
#LEXER_SOURCES = $(UNICODE_CATEGORY_SOURCES) $(CROOT)/lexer.l
#$(CROOT)/lexer.c $(CROOT)/lexer.h: $(LEXER_SOURCES) $(CROOT)/grammar.h
#	$(LEX) --outfile=$(CROOT)/lexer.c --header-file=$(CROOT)/lexer.h $(LEXER_SOURCES)
#	patch -p1 < $(CROOT)/lexer.patch
FLEX_VERSION=$(shell $(LEX) -V)
$(CROOT)/lexer.c $(CROOT)/lexer.h: $(CROOT)/lexer.l $(CROOT)/grammar.h
	$(LEX) --outfile=$(CROOT)/lexer.c --header-file=$(CROOT)/lexer.h $<


SOURCES =					\
	$(CROOT)/lexer.c			\
	$(CROOT)/lexer.h			\
	$(CROOT)/grammar.c			\
	$(CROOT)/grammar.h

.PHONY: build
build: $(SOURCES)
	$(PYTHON) setup.py build_ext -i

build35: $(SOURCES)
	python3.5 setup.py build_ext -i


# Dump the lexer parsed output. This can be used to check across languages.
dump_lexer:
	bean-dump-lexer $(INPUT)


# Check for memory leaks.
grind:
	valgrind --leak-check=full $(PYTHON) bean-sandbox $(INPUT)

# Regenerate the website.
html docs:
	projects docs beancount

# Compute and plot inter-module dependencies.
# We want to insure a really strict set of relationships between the modules,
# and this is the high-level picture.
build/beancount.deps:
	sfood -i bin beancount > $@

CLUSTERS_REGEXPS =							\
	beancount/core/.*_test\.py	 	core/tests		\
	beancount/core			 	core			\
	beancount/ops/.*_test\.py	 	ops/tests		\
	beancount/ops			 	ops			\
	beancount/parser/printer_test\.py 	printer/tests		\
	beancount/parser/printer.py	 	printer			\
	beancount/parser/options_test\.py 	options/tests		\
	beancount/parser/options.py	 	options			\
	beancount/parser/.*_test\.py	 	parser/tests		\
	beancount/parser		 	parser			\
	beancount/plugins/.*_test\.py	 	plugins/tests		\
	beancount/plugins		 	plugins			\
	beancount/reports/.*_test\.py	 	reports/tests		\
	beancount/reports		 	reports			\
	beancount/scripts/bake.*_test\.py	scripts/bake/tests	\
	beancount/scripts/bake.*		scripts/bake		\
	beancount/scripts/.*_test\.py	 	scripts/tests		\
	beancount/scripts		 	scripts			\
	beancount/utils/.*_test\.py	 	utils/tests		\
	beancount/utils			 	utils			\
	beancount/web/.*_test\.py	 	web/tests		\
	beancount/web			 	web			\
	beancount/query/.*_test\.py	 	query/tests		\
	beancount/query			 	query			\
	beancount/load.*_test\.py	 	load/tests		\
	beancount/load.*\.py		 	load			\
	beancount                        	load

GRAPHER = dot

build/beancount.pdf: build/beancount.deps
	cat $< | sfood-cluster-regexp $(CLUSTERS_REGEXPS) | grep -v /tests | sfood-graph | $(GRAPHER) -Tps | ps2pdf - $@
	evince $@

build/beancount_tests.pdf: build/beancount.deps
	cat $< | sfood-cluster-regexp $(CLUSTERS_REGEXPS) | sfood-graph | $(GRAPHER) -Tps | ps2pdf - $@
	evince $@



# Compute ahd plot the dependencies within the core.
# We are considering a separation of the basic data structure and the basic operations.
# This provides the detail of the relationships between these sets of fils.
build/beancount-core.pdf: build/beancount-core.deps
	sfood -ii beancount/core/*.py | sfood-graph | $(GRAPHER) -Tps | ps2pdf - $@

showdeps-core: build/beancount-core.pdf
	evince $<


# Run in the debugger.
debug:
	gdb --args $(PYTHON) /home/blais/p/beancount/bin/bean-sandbox $(INPUT)


# Push to github.
github:
	hg bookmark -r default master
	hg push git+ssh://git@github.com/blais/beancount

# Bake a release.
release:
	$(PYTHON) setup.py register sdist upload


vtest vtests verbose-test verbose-tests:
	$(PYTHON) -m pytest -v -s beancount examples

qtest qtests quiet-test quiet-tests test tests:
	$(PYTHON) -m pytest beancount

test-last test-last-failed test-failed:
	$(PYTHON) -m pytest --last-failed beancount

test-naked:
	PATH=/bin:/usr/bin PYTHONPATH= $(PYTHON) -m pytest -x beancount

# Run the parser and measure its performance.
.PHONY: check
check:
	bean-check $(INPUT)


# Run the demo program.
demo:
	bin/bean-web --debug examples/demo.beancount


# Generate the tutorial files from the example file.
EXAMPLE=examples/example.beancount
example $(EXAMPLE):
	./bin/bean-example --seed=0 -o $(EXAMPLE)

TUTORIAL=examples/tutorial
tutorial: $(EXAMPLE)
	$(PYTHON) beancount/scripts/tutorial.py $(EXAMPLE) $(TUTORIAL)


# Run the web server.
.PHONY: web
web:
	bean-web --debug $(INPUT)

.PHONY: web-incognito
web-incognito:
	bean-web --incognito --debug $(INPUT)


# Run the importer.
.PHONY: import
import:
	bean-import $(INPUT) $(DOWNLOADS)

# My development sandbox script. This is messy and it's okay.
.PHONY: sandbox
sandbox:
	bean-sandbox $(INPUT)

missing-tests:
	$(TOOLS)/find_missing_tests.py beancount

fixmes:
	egrep -srn '\b(FIXME|TODO\()' beancount || true

filter-terms:
	egrep --exclude-dir='.hg' --exclude-dir='__pycache__' -srn 'GOOGL?\b' $(PWD) | grep -v GOOGLE_APIS || true

multi-imports:
	(egrep -srn '^(from.*)?import.*,' beancount | grep -v 'from typing') || true

# Check for unused imports.
sfood-checker:
	sfood-checker bin beancount

# Check dependency constraints.
constraints dep-constraints: build/beancount.deps
	$(TOOLS)/dependency_constraints.py $<


# Run the linter on all source code.
# To list all messages, call: "pylint --list-msgs"
LINT_SRCS =					\
  beancount					\
  examples/ingest/office/importers		\
  bin/*						\
  tools/*.py

# Note: Keeping to 3.5 because 3.6 pylint raises an exception (as of 2017-01-15).
#PYLINT = pylint
PYLINT = python3 $(shell which pylint)

pylint lint:
	$(PYLINT) --rcfile=$(PWD)/etc/pylintrc $(LINT_SRCS)

LINT_TESTS=useless-suppression,empty-docstring
pylint-only:
	$(PYLINT) --rcfile=$(PWD)/etc/pylintrc --disable=all --enable=$(LINT_TESTS) $(LINT_SRCS)

pyflakes:
	pyflakes $(LINT_SRCS)


# Check everything.
status check: pylint pyflakes filter-terms missing-tests dep-constraints multi-imports test


# Experimental docs conversion.
download-pdf:
	./tools/download_docs.py pdf $(HOME)/p/beancount-downloads/pdf

download-odt:
	./tools/download_docs.py odt $(HOME)/p/beancount-downloads/odt

sphinx sphinx_odt2rst:
	./tools/sphinx_odt2rst.py $(HOME)/p/beancount-downloads/odt $(HOME)/p/beancount-docs

convert_test:
	./tools/convert_doc.py --cache=/tmp/convert_test.cache '1WjARst_cSxNE-Lq6JnJ5CC41T3WndEsiMw4d46r2694' /tmp/trading.md

# This does not work well; import errors just won't go away, it's slow, and it
# seems you have to pregenerate all .pyi to do anything useful.
pytype:
	find $(PWD)/beancount -name '*.py' | parallel -j16  pytype --pythonpath=$(PWD) -o {}i {}

pytype1:
	pytype --pythonpath=$(PWD) beancount/utils/net_utils.py

=== experiments/docs_rst/Makefile ===
#!/usr/bin/env make

# Directory where the downloaded files are located (either downloaded using the
# Google Drive API or decompressed from the provided archive).
CONVERT_DOCS=$(HOME)/docs

# Directory of Dominik Aumayr's static docs generator source.
RST_DOCS=$(HOME)/p/beancount-docs

# Download all the docs.
download:
	mkdir -p $(CONVERT_DOCS)
	./download_docs.py $(CONVERT_DOCS)

# Convert all the docs.
convert:
	./convert_docs.py $(CONVERT_DOCS)

# Copy the docs to the static archive.
# (You can then go and build then using Sphinx and inspect them.)
copy:
	./copy_docs.py $(CONVERT_DOCS) $(RST_DOCS)

=== experiments/washsales/Makefile ===
#!/usr/bin/env make

wash:
	$(PWD)/wash_calculator.py $(L) HOOL HOOLB

test:
	pytest $(PWD)

=== debian/changelog ===
beancount (2.2.0-3) unstable; urgency=medium

  [ Santiago Vila ]
  * patches/0003: Ignore FileNotFoundError from self.tmpdir.cleanup().
    Fixes a FTBFS problem which happens randomly (Closes: #923606)

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 21 Apr 2019 17:00:36 +0200

beancount (2.2.0-2) unstable; urgency=medium

  * rules: do not ship *.picklecache files with Python examples (fixes
    build unreproducibility on armhf)
  * manpages/whatis.txt: provide sensible whatis entries for manpages
    (fixes lintian warnings)

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 14 Jan 2019 10:01:37 +0100

beancount (2.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 08 Jan 2019 21:31:17 +0100

beancount (2.1.3+hg20181225-3) unstable; urgency=medium

  * rules: do not ship __pycache__ dirs with Python examples
  * control: bump Standards-Version, no changes needed
  * compat: bump debhelper level to 12

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 07 Jan 2019 13:45:11 +0100

beancount (2.1.3+hg20181225-2) unstable; urgency=medium

  * rules: simplify manpage dir creation
  * ship upstream examples
  * ship upstream info about where to find online documentation
  * copyright: release packaging files under GPL2 or later
  * copyright: document missing copyright and license for
    beancount/web/third_party/sorttable.js (Closes: #917960)

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 01 Jan 2019 19:09:05 +0100

beancount (2.1.3+hg20181225-1) experimental; urgency=medium

  [ Nicolas Dandrimont ]
  * Initial release. (Closes: #799626)
  * patches/0001: remove fonts.googleapis.com links from bean-web template

  [ Stefano Zacchiroli ]
  * Update to upstream version 2.1.3 + recent hg snapshot
  * patches/0002: make test_version more lax to accept non git/hg versions

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 26 Dec 2018 09:05:09 +0100

=== debian/control ===
Source: beancount
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Nicolas Dandrimont <olasd@debian.org>, Stefano Zacchiroli <zack@debian.org>
Vcs-Browser: https://salsa.debian.org/python-team/applications/beancount
Vcs-Git: https://salsa.debian.org/python-team/applications/beancount.git
Homepage: http://furius.ca/beancount/
Standards-Version: 4.3.0
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12~),
               dh-elpa,
               dh-python (>= 3~),
               gnupg,
               help2man <!nodoc>,
               ledger,
               python3-all,
               python3-all-dev,
               python3-bottle,
               python3-bs4,
               python3-chardet,
               python3-dateutil,
               python3-googleapi,
               python3-lxml,
               python3-magic,
               python3-ply,
               python3-pytest,
               python3-requests,
               python3-setuptools,
Rules-Requires-Root: no

Package: beancount
Architecture: all
Depends: python3,
         python3-beancount (<< ${source:Version}.1~),
         python3-beancount (>= ${source:Version}),
         ${elpa:Depends},
         ${misc:Depends}
Description: Double-entry accounting from text files
 A double-entry bookkeeping computer language that lets you define financial
 transaction records in a text file, read them in memory, generate a variety of
 reports from them, and provides a web interface.
 .
 The following features require the following extra dependencies to be
 installed:
  - Beancount Web [python3-bottle]
  - OFX import [python3-bs4]
  - Google Sheets upload [python3-googleapi]
  - External price imports [python3-requests]

Package: python3-beancount
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Recommends: ${python3:Recommends}
Suggests: ${python3:Suggests}
Description: Double-entry accounting from text files - Python module
 A double-entry bookkeeping computer language that lets you define financial
 transaction records in a text file, read them in memory, generate a variety of
 reports from them, and provides a web interface.
 .
 The following features require the following extra dependencies to be
 installed:
  - Beancount Web [python3-bottle]
  - OFX import [python3-bs4]
  - Google Sheets upload [python3-googleapi]
  - External price imports [python3-requests]
 .
 This package provides the underlying Python modules for beancount, allowing
 you to write your own scripts to manipulate your ledger files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

export PYBUILD_AFTER_BUILD=chmod +x {build_dir}/beancount/tools/treeify.py {build_dir}/beancount/tools/sheets_upload.py; rm {build_dir}/beancount/scripts/setup_test.py
export PYBUILD_TEST_ARGS=-v
export PYBUILD_BEFORE_TEST=cp -r $(CURDIR)/beancount/utils/file_type {build_dir}/beancount/utils; cd $(CURDIR)/beancount/parser; cp lexer.l grammar.y parser.h parser.c {build_dir}/beancount/parser
export PYBUILD_AFTER_TEST=rm -r {build_dir}/beancount/utils; cd {build_dir}/beancount/parser; rm lexer.l grammar.y parser.h parser.c

%:
	dh $@ --with python3,elpa --buildsystem pybuild

override_dh_python3:
	dh_python3 --recommends bottle --suggests google-api-python-client --suggests beautifulsoup4 --suggests requests

override_dh_auto_build:
	dh_auto_build

	sed s/#VERSION#/$(DEB_VERSION_UPSTREAM)/g $(CURDIR)/debian/beancount-pkg.el.in > $(CURDIR)/editors/emacs/beancount-pkg.el

ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	cd $(CURDIR)/bin; \
	  for binary in *; do \
	    PYTHONPATH=$$(cd $(CURDIR); pybuild --print build_dir --interpreter python3) \
	      help2man \
		--name "$$(grep $$binary $(CURDIR)/debian/manpages/whatis.txt | cut -f 2)" \
	        --no-info \
	        --help-option=-h \
	        --version-string=$(DEB_VERSION_UPSTREAM) \
	        ./$$binary > $(CURDIR)/debian/manpages/$$binary.1 ; \
	  done
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/manpages/*.1

override_dh_auto_install:
	dh_auto_install
	rm -r $(CURDIR)/debian/tmp/usr/elisp

override_dh_installexamples:
	dh_installexamples -X __pycache__ -X .picklecache

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://bitbucket.org/blais/beancount/downloads/?tab=tags .*/(\d.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## beancount 2.2.3

=== debian/changelog ===
beancount (2.2.3-1ubuntu2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:16:49 +0100

beancount (2.2.3-1ubuntu1) focal; urgency=medium

  * Fix segfault with python3.8, taken from upstream.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 29 Jan 2020 06:39:45 +0100

beancount (2.2.3-1) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.
  * Bump Standards-Version to 4.4.1.
  * d/changelog: Remove trailing whitespaces.

  [ Dr. Tobias Quathamer ]
  * New upstream version 2.2.3
    - Remove patch 'Ignore FileNotFoundError from self.tmpdir.cleanup()'
      The patch has been applied upstream. Refresh remaining patches.
  * Use d/watch version 4

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 24 Oct 2019 22:56:15 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 
 %:
 	dh $@ --with python3,elpa --buildsystem pybuild
+
+override_dh_auto_test:
+	-dh_auto_test
 
 override_dh_python3:
 	dh_python3 --recommends bottle --suggests google-api-python-client --suggests beautifulsoup4 --suggests requests

## beancount 2.2.3%2Bhg20200223.0.3af921a

=== debian/changelog ===
beancount (2.2.3+hg20200223.0.3af921a-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.2.3+hg20200223.0.3af921a
    - Work around a Python3.8 bug causing a segfault (Closes: #943608)
    - Refresh patches
    - Add patch to adjust beancount version
    - Add new patch to disable three failing tests with Python 3.7
  * Convert package version for dh_elpa, as '+hg2020...' is invalid

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 10 Mar 2020 21:46:39 +0100

beancount (2.2.3-2) unstable; urgency=medium

  * Team upload
  * d/p/0003: Work around a Python3.8 bug causing a segfault (Closes: #943608)

 -- Pierre-Elliott Bécue <peb@debian.org>  Wed, 25 Dec 2019 19:35:31 +0100

## beancount 2.2.3+hg20200223.0.3af921a

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,8 @@
 #LEX = flex -Ca
 LEX = flex
 
-YACC = bison --report=itemset --verbose
+# Note: -Wno-deprecated silences warnings about old directives from upgrading to 3.4.
+YACC = bison -Wno-deprecated --report=itemset --verbose
 FILTERYACC = sed -e 's@/\*[ \t]yacc\.c:.*\*/@@'
 TMP=/tmp
 
@@ -149,7 +150,7 @@
 # Push to github.
 github:
 	hg bookmark -r default master
-	hg push git+ssh://git@github.com/blais/beancount
+	hg push git+ssh://git@github.com/beancount/beancount
 
 # Bake a release.
 release:
@@ -240,7 +241,7 @@
 
 # Note: Keeping to 3.5 because 3.6 pylint raises an exception (as of 2017-01-15).
 #PYLINT = pylint
-PYLINT = python3 $(shell which pylint)
+PYLINT = python3 -m pylint
 
 pylint lint:
 	$(PYLINT) --rcfile=$(PWD)/etc/pylintrc $(LINT_SRCS)

=== requirements.txt ===
python-dateutil>=2.6.0
bottle>=0.12
ply>=3.4
lxml>=3.0
google-api-python-client>=1.6.0
oauth2client>=4.0
httplib2>=0.10
requests>=2.0
beautifulsoup4>=4
python-magic>=0.4.12

=== editors/emacs/Makefile ===
EMACS ?= emacs
SRC = beancount.el
TESTS = beancount-tests.el

compile: $(SRC)
	$(EMACS) -batch -f batch-byte-compile $<

test:
	$(EMACS) -batch -L . -l ert -l $(TESTS) -f ert-run-tests-batch-and-exit

=== experiments/inventory/Makefile ===
#!/usr/bin/env make

assets_pb2.py: assets.proto
	protoc -I . --python_out . --proto_path . $<

=== experiments/protos/Makefile ===
#!/usr/bin/env make

beancount_pb2.py: beancount.proto
	protoc -I . --python_out . --proto_path . $<

=== experiments/v3/Makefile ===
#!/usr/bin/env make


all: build export convert view

build:
	bazel build -c opt //experiments/...

export:
	time ./bazel-bin/experiments/protos/export_as_protos $(L)

convert:
	time ./bazel-bin/experiments/tools/riegeli_print /tmp/ledger.rieg > /tmp/ledger.text

view:
	less /tmp/ledger.text

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Vcs-Browser: https://salsa.debian.org/python-team/applications/beancount
 Vcs-Git: https://salsa.debian.org/python-team/applications/beancount.git
 Homepage: http://furius.ca/beancount/
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 12),
                dh-elpa,
                dh-python (>= 3~),
                gnupg,

=== debian/rules ===
--- 
+++ 
@@ -6,14 +6,11 @@
 
 export PYBUILD_AFTER_BUILD=chmod +x {build_dir}/beancount/tools/treeify.py {build_dir}/beancount/tools/sheets_upload.py; rm {build_dir}/beancount/scripts/setup_test.py
 export PYBUILD_TEST_ARGS=-v
-export PYBUILD_BEFORE_TEST=cp -r $(CURDIR)/beancount/utils/file_type {build_dir}/beancount/utils; cd $(CURDIR)/beancount/parser; cp lexer.l grammar.y parser.h parser.c {build_dir}/beancount/parser
+export PYBUILD_BEFORE_TEST=cp -r $(CURDIR)/beancount/utils/file_type_testdata {build_dir}/beancount/utils; cd $(CURDIR)/beancount/parser; cp lexer.l grammar.y parser.h parser.c {build_dir}/beancount/parser
 export PYBUILD_AFTER_TEST=rm -r {build_dir}/beancount/utils; cd {build_dir}/beancount/parser; rm lexer.l grammar.y parser.h parser.c
 
 %:
 	dh $@ --with python3,elpa --buildsystem pybuild
-
-override_dh_auto_test:
-	-dh_auto_test
 
 override_dh_python3:
 	dh_python3 --recommends bottle --suggests google-api-python-client --suggests beautifulsoup4 --suggests requests
@@ -22,6 +19,9 @@
 	dh_auto_build
 
 	sed s/#VERSION#/$(DEB_VERSION_UPSTREAM)/g $(CURDIR)/debian/beancount-pkg.el.in > $(CURDIR)/editors/emacs/beancount-pkg.el
+	# Temporary fix for the hg based release, dh_elpa considers
+	# a version with a '+hg2020...' in it as invalid.
+	sed -i s/\+hg[^\"]*/.0/g $(CURDIR)/editors/emacs/beancount-pkg.el
 
 ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
 	cd $(CURDIR)/bin; \

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://bitbucket.org/blais/beancount/downloads/?tab=tags .*/(\d.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## beancount 2.3.3

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,25 @@
 #!/usr/bin/env make
 
-# Just my big old fat ledger file.
 INPUT = $(HOME)/q/office/accounting/blais.beancount
 DOWNLOADS = $(HOME)/u/Downloads
-
-GREP="grep --include="*.py" -srnE"
 TOOLS=./tools
 
-PYTHON?=python3
+PYTHON ?= python3
+PYLINT ?= $(PYTHON) -m pylint
+LEX = flex
+YACC = bison
+YFLAGS = --report=itemset --verbose -Wall -Werror
+GRAPHER = dot
+
+
+# Support PYTHON being the path to a python interpreter.
+PYVERSION = $(shell $(PYTHON) -c 'import platform; print(".".join(platform.python_version_tuple()[:2]))')
+PYCONFIG = "python$(PYVERSION)-config"
+CFLAGS += $(shell $(PYCONFIG) --cflags) -I$(PWD) -fPIE -UNDEBUG -Wno-unused-function -Wno-unused-variable
+LDFLAGS += $(shell $(PYCONFIG) --embed --ldflags)
+LDLIBS += $(shell $(PYCONFIG) --embed --libs)
 
 all: build
-
 
 # Clean everything up.
 clean:
@@ -19,54 +28,38 @@
 	rm -f $(CROOT)/grammar.h $(CROOT)/grammar.c
 	rm -f $(CROOT)/lexer.h $(CROOT)/lexer.c
 	rm -f $(CROOT)/*.so
+	rm -f $(CROOT)/tokens_test
 	find . -name __pycache__ -exec rm -r "{}" \; -prune
-
 
 # Targets to generate and compile the C parser.
 CROOT = beancount/parser
 
-# See
-# https://www.owlfolio.org/possibly-useful/flex-input-scanner-rules-are-too-complicated/
-#LEX = flex -Ca
-LEX = flex
-
-# Note: -Wno-deprecated silences warnings about old directives from upgrading to 3.4.
-YACC = bison -Wno-deprecated --report=itemset --verbose
-FILTERYACC = sed -e 's@/\*[ \t]yacc\.c:.*\*/@@'
-TMP=/tmp
-
 $(CROOT)/grammar.c $(CROOT)/grammar.h: $(CROOT)/grammar.y
-	$(YACC) -o $(CROOT)/grammar.c $<
-	(cat $(CROOT)/grammar.c | $(FILTERYACC) > $(TMP)/grammar.c ; mv $(TMP)/grammar.c $(CROOT)/grammar.c )
-	(cat $(CROOT)/grammar.h | $(FILTERYACC) > $(TMP)/grammar.h ; mv $(TMP)/grammar.h $(CROOT)/grammar.h )
-
-UNICODE_CATEGORY_RANGES_GENERATOR=$(TOOLS)/generate_unicode_category_regexps.py
-UNICODE_CATEGORY_DIR = $(CROOT)/lexer
-UNICODE_CATEGORIES = Lu Ll Lt Lo Nd Nl No
-UNICODE_CATEGORY_SOURCES = $(patsubst %, $(UNICODE_CATEGORY_DIR)/%.l, $(UNICODE_CATEGORIES))
-$(UNICODE_CATEGORY_SOURCES): $(UNICODE_CATEGORY_DIR)/%.l :
-	$(PYTHON) $(UNICODE_CATEGORY_RANGES_GENERATOR) \
-		--format=lex --name=UTF-8-$* --categories=$* >$@
-
-# Note that flex parses the files in the given order.
-#LEXER_SOURCES = $(UNICODE_CATEGORY_SOURCES) $(CROOT)/lexer.l
-#$(CROOT)/lexer.c $(CROOT)/lexer.h: $(LEXER_SOURCES) $(CROOT)/grammar.h
-#	$(LEX) --outfile=$(CROOT)/lexer.c --header-file=$(CROOT)/lexer.h $(LEXER_SOURCES)
-#	patch -p1 < $(CROOT)/lexer.patch
-FLEX_VERSION=$(shell $(LEX) -V)
+	$(YACC) $(YFLAGS) -o $(CROOT)/grammar.c $<
+
 $(CROOT)/lexer.c $(CROOT)/lexer.h: $(CROOT)/lexer.l $(CROOT)/grammar.h
 	$(LEX) --outfile=$(CROOT)/lexer.c --header-file=$(CROOT)/lexer.h $<
 
 
 SOURCES =					\
+	$(CROOT)/decimal.c			\
+	$(CROOT)/decimal.h 			\
 	$(CROOT)/lexer.c			\
 	$(CROOT)/lexer.h			\
 	$(CROOT)/grammar.c			\
-	$(CROOT)/grammar.h
+	$(CROOT)/grammar.h			\
+	$(CROOT)/macros.h			\
+	$(CROOT)/tokens.h
 
 .PHONY: build
 build: $(SOURCES)
 	$(PYTHON) setup.py build_ext -i
+
+$(CROOT)/tokens_test: $(CROOT)/tokens_test.o $(CROOT)/tokens.o $(CROOT)/decimal.o
+
+.PHONY: ctest
+ctest: $(CROOT)/tokens_test
+	$(CROOT)/tokens_test
 
 build35: $(SOURCES)
 	python3.5 setup.py build_ext -i
@@ -120,7 +113,6 @@
 	beancount/load.*\.py		 	load			\
 	beancount                        	load
 
-GRAPHER = dot
 
 build/beancount.pdf: build/beancount.deps
 	cat $< | sfood-cluster-regexp $(CLUSTERS_REGEXPS) | grep -v /tests | sfood-graph | $(GRAPHER) -Tps | ps2pdf - $@
@@ -146,16 +138,9 @@
 debug:
 	gdb --args $(PYTHON) /home/blais/p/beancount/bin/bean-sandbox $(INPUT)
 
-
-# Push to github.
-github:
-	hg bookmark -r default master
-	hg push git+ssh://git@github.com/beancount/beancount
-
-# Bake a release.
+# Bake a release, upload the source.
 release:
-	$(PYTHON) setup.py register sdist upload
-
+	twine upload dist/*.tar.gz
 
 vtest vtests verbose-test verbose-tests:
 	$(PYTHON) -m pytest -v -s beancount examples
@@ -180,14 +165,10 @@
 	bin/bean-web --debug examples/demo.beancount
 
 
-# Generate the tutorial files from the example file.
+# Generate the example file.
 EXAMPLE=examples/example.beancount
 example $(EXAMPLE):
 	./bin/bean-example --seed=0 -o $(EXAMPLE)
-
-TUTORIAL=examples/tutorial
-tutorial: $(EXAMPLE)
-	$(PYTHON) beancount/scripts/tutorial.py $(EXAMPLE) $(TUTORIAL)
 
 
 # Run the web server.
@@ -239,16 +220,12 @@
   bin/*						\
   tools/*.py
 
-# Note: Keeping to 3.5 because 3.6 pylint raises an exception (as of 2017-01-15).
-#PYLINT = pylint
-PYLINT = python3 -m pylint
-
 pylint lint:
-	$(PYLINT) --rcfile=$(PWD)/etc/pylintrc $(LINT_SRCS)
+	$(PYLINT) $(LINT_SRCS)
 
 LINT_TESTS=useless-suppression,empty-docstring
 pylint-only:
-	$(PYLINT) --rcfile=$(PWD)/etc/pylintrc --disable=all --enable=$(LINT_TESTS) $(LINT_SRCS)
+	$(PYLINT) --disable=all --enable=$(LINT_TESTS) $(LINT_SRCS)
 
 pyflakes:
 	pyflakes $(LINT_SRCS)
@@ -278,3 +255,7 @@
 
 pytype1:
 	pytype --pythonpath=$(PWD) beancount/utils/net_utils.py
+
+bazel-link:
+	rm -f beancount/parser/_parser.so
+	ln -s ../../bazel-bin/beancount/parser/_parser.so beancount/parser/_parser.so

=== requirements.txt ===
python-dateutil>=2.6.0
bottle>=0.12
ply>=3.4
lxml>=3.0
google-api-python-client>=1.8.2
oauth2client>=4.0
httplib2>=0.10
requests>=2.0
beautifulsoup4>=4
python-magic>=0.4.12; sys_platform != 'win32'

=== debian/changelog ===
beancount (2.3.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.3
  * Remove support for Emacs.
    Upstream has moved those files to a separate project,
    see https://github.com/beancount/beancount-mode
  * Update Standards-Version to 4.5.1, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 18 Nov 2020 20:13:06 +0100

beancount (2.3.1-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Team upload.
  * Patch: Support testing against multiple python3.x versions.
    (Closes: #972328)

  [ Ondřej Nový ]
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 16 Oct 2020 10:36:42 -0700

beancount (2.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.1
    - Update d/watch and d/copyright to new upstream URL
    - Refresh patches
    - New patch: Remove failing test for now
    - Revert temporary fix for dh_elpa
  * Add 'Recommends: fava' to beancount binary package
  * Use debhelper-compat v13
  * Update Standards-Version to 4.5.0, no changes needed
  * Do not generate a manpage for the BUILD script

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 06 Sep 2020 21:58:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: beancount
-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Nicolas Dandrimont <olasd@debian.org>, Stefano Zacchiroli <zack@debian.org>
-Vcs-Browser: https://salsa.debian.org/python-team/applications/beancount
-Vcs-Git: https://salsa.debian.org/python-team/applications/beancount.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/beancount
+Vcs-Git: https://salsa.debian.org/python-team/packages/beancount.git
 Homepage: http://furius.ca/beancount/
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Section: utils
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               dh-elpa,
+Build-Depends: debhelper-compat (= 13),
                dh-python (>= 3~),
                gnupg,
                help2man <!nodoc>,
@@ -33,8 +32,8 @@
 Depends: python3,
          python3-beancount (<< ${source:Version}.1~),
          python3-beancount (>= ${source:Version}),
-         ${elpa:Depends},
          ${misc:Depends}
+Recommends: fava
 Description: Double-entry accounting from text files
  A double-entry bookkeeping computer language that lets you define financial
  transaction records in a text file, read them in memory, generate a variety of

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 export PYBUILD_AFTER_TEST=rm -r {build_dir}/beancount/utils; cd {build_dir}/beancount/parser; rm lexer.l grammar.y parser.h parser.c
 
 %:
-	dh $@ --with python3,elpa --buildsystem pybuild
+	dh $@ --with python3 --buildsystem pybuild
 
 override_dh_python3:
 	dh_python3 --recommends bottle --suggests google-api-python-client --suggests beautifulsoup4 --suggests requests
@@ -18,17 +18,13 @@
 override_dh_auto_build:
 	dh_auto_build
 
-	sed s/#VERSION#/$(DEB_VERSION_UPSTREAM)/g $(CURDIR)/debian/beancount-pkg.el.in > $(CURDIR)/editors/emacs/beancount-pkg.el
-	# Temporary fix for the hg based release, dh_elpa considers
-	# a version with a '+hg2020...' in it as invalid.
-	sed -i s/\+hg[^\"]*/.0/g $(CURDIR)/editors/emacs/beancount-pkg.el
-
 ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
 	cd $(CURDIR)/bin; \
 	  for binary in *; do \
+	    if [ "X$$binary" = "XBUILD" ]; then continue; fi ; \
 	    PYTHONPATH=$$(cd $(CURDIR); pybuild --print build_dir --interpreter python3) \
 	      help2man \
-		--name "$$(grep $$binary $(CURDIR)/debian/manpages/whatis.txt | cut -f 2)" \
+	        --name "$$(grep $$binary $(CURDIR)/debian/manpages/whatis.txt | cut -f 2)" \
 	        --no-info \
 	        --help-option=-h \
 	        --version-string=$(DEB_VERSION_UPSTREAM) \
@@ -40,10 +36,6 @@
 	dh_auto_clean
 	rm -f debian/manpages/*.1
 
-override_dh_auto_install:
-	dh_auto_install
-	rm -r $(CURDIR)/debian/tmp/usr/elisp
-
 override_dh_installexamples:
 	dh_installexamples -X __pycache__ -X .picklecache

## beancount 2.3.5

=== Makefile ===
--- 
+++ 
@@ -140,7 +140,11 @@
 
 # Bake a release, upload the source.
 release:
-	twine upload dist/*.tar.gz
+	rm -rf dist
+	python3 setup.py sdist
+	python3.10 setup.py bdist_egg
+	python3.9 setup.py bdist_egg
+	twine upload dist/*.tar.gz dist/*.egg
 
 vtest vtests verbose-test verbose-tests:
 	$(PYTHON) -m pytest -v -s beancount examples

=== requirements.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 ply>=3.4
 lxml>=3.0
 google-api-python-client>=1.8.2
+google_auth_oauthlib>=0.4.2
 oauth2client>=4.0
 httplib2>=0.10
 requests>=2.0

=== debian/changelog ===
beancount (2.3.5-2) unstable; urgency=medium

  * Team upload.
  * Apply upstream proposed patch fixing quotechar FTBFS (Closes: #1024207)

 -- Blair Noctis <n@sail.ng>  Fri, 18 Nov 2022 16:45:00 +0000

beancount (2.3.5-1) unstable; urgency=medium

  * Team upload.

  [ Blair Noctis ]
  * New upstream version 2.3.5

  [ Dr. Tobias Quathamer ]
  * Update homepage
  * Update Standards-Version to 4.6.1, no changes needed
  * Update d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 22 Oct 2022 17:45:28 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Uploaders: Nicolas Dandrimont <olasd@debian.org>, Stefano Zacchiroli <zack@debian.org>
 Vcs-Browser: https://salsa.debian.org/python-team/packages/beancount
 Vcs-Git: https://salsa.debian.org/python-team/packages/beancount.git
-Homepage: http://furius.ca/beancount/
-Standards-Version: 4.5.1
+Homepage: https://github.com/beancount/
+Standards-Version: 4.6.1
 Section: utils
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -19,6 +19,7 @@
                python3-chardet,
                python3-dateutil,
                python3-googleapi,
+               python3-google-auth-oauthlib,
                python3-lxml,
                python3-magic,
                python3-ply,
@@ -43,7 +44,7 @@
  installed:
   - Beancount Web [python3-bottle]
   - OFX import [python3-bs4]
-  - Google Sheets upload [python3-googleapi]
+  - Google Sheets upload [python3-googleapi python3-google-auth-oauthlib]
   - External price imports [python3-requests]
 
 Package: python3-beancount
@@ -61,7 +62,7 @@
  installed:
   - Beancount Web [python3-bottle]
   - OFX import [python3-bs4]
-  - Google Sheets upload [python3-googleapi]
+  - Google Sheets upload [python3-googleapi python3-google-auth-oauthlib]
   - External price imports [python3-requests]
  .
  This package provides the underlying Python modules for beancount, allowing

## beancount 2.3.6

=== Makefile ===
--- 
+++ 
@@ -138,14 +138,6 @@
 debug:
 	gdb --args $(PYTHON) /home/blais/p/beancount/bin/bean-sandbox $(INPUT)
 
-# Bake a release, upload the source.
-release:
-	rm -rf dist
-	python3 setup.py sdist
-	python3.10 setup.py bdist_egg
-	python3.9 setup.py bdist_egg
-	twine upload dist/*.tar.gz dist/*.egg
-
 vtest vtests verbose-test verbose-tests:
 	$(PYTHON) -m pytest -v -s beancount examples
 
@@ -234,6 +226,9 @@
 pyflakes:
 	pyflakes $(LINT_SRCS)
 
+ruff:
+	ruff beancount examples/ingest/office/importers tools
+
 
 # Check everything.
 status check: pylint pyflakes filter-terms missing-tests dep-constraints multi-imports test

=== requirements.txt ===
setuptools>=60.0; python_version >= '3.12'
beautifulsoup4>=4
chardet>=5.0
bottle>=0.12
google-api-python-client>=1.8.2
google_auth_oauthlib>=0.4.2
httplib2>=0.10
lxml>=3.0
oauth2client>=4.0
ply>=3.4
python-dateutil>=2.6.0
python-magic>=0.4.12; sys_platform != 'win32'
requests>=2.0

=== debian/changelog ===
beancount (2.3.6-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 18:36:01 +0000

beancount (2.3.6-1) unstable; urgency=high

  * Team upload.
  * New upstream release.
    + Fix compatibility with python3.12. (Closes: #1055684)
  * debian/control:
    + Add new build-dependency to python3-oauth2client.
    + Add new build-test-dependency python3-pdfminer.
    + Mark python3-pytest and python3-pdfminer as <!nocheck>.
    + Replace dh-python with dh-sequence-python3.
    + Bump Standards-Version to 4.6.2.
  * debian/rules:
    + Do not override dh_missing.
    + Remove now useless "--with python3" parameter.
    + Use "execute_after_dh_*" targets when possible.
    + Rename base beancount directory in dh_auto_test to avoid importing
      the wrong beancount library during test.
  * debian/patches/:
    - Drop old patch on quotechar, upstream has an alternative fix.
    - Drop old patch on testimport.py, merged upstream.
    + debian/patches/backport/: Backport trunk commits till 2023-11-19.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Dec 2023 00:31:17 -0500

beancount (2.3.5-3) unstable; urgency=medium

  * Team upload.
  * debian/rules: Do not disable pie in hardening to avoid FTBFS
    with LTO. Now we enable all default hardening flags and do not
    explicitly disable any hardening feature. (Closes: #1015359)

 -- Boyuan Yang <byang@debian.org>  Fri, 13 Oct 2023 09:31:42 -0400

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Vcs-Browser: https://salsa.debian.org/python-team/packages/beancount
 Vcs-Git: https://salsa.debian.org/python-team/packages/beancount.git
 Homepage: https://github.com/beancount/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: utils
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-python (>= 3~),
+               dh-sequence-python3,
                gnupg,
                help2man <!nodoc>,
                ledger,
@@ -22,8 +22,10 @@
                python3-google-auth-oauthlib,
                python3-lxml,
                python3-magic,
+               python3-oauth2client,
+               python3-pdfminer <!nocheck>,
                python3-ply,
-               python3-pytest,
+               python3-pytest <!nocheck>,
                python3-requests,
                python3-setuptools,
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export PYBUILD_AFTER_BUILD=chmod +x {build_dir}/beancount/tools/treeify.py {build_dir}/beancount/tools/sheets_upload.py; rm {build_dir}/beancount/scripts/setup_test.py
export PYBUILD_TEST_ARGS=-v
export PYBUILD_BEFORE_TEST=cp -r $(CURDIR)/beancount/utils/file_type_testdata {build_dir}/beancount/utils; cd $(CURDIR)/beancount/parser; cp lexer.l grammar.y parser.h parser.c {build_dir}/beancount/parser; mv $(CURDIR)/beancount $(CURDIR)/beancount_backup
export PYBUILD_AFTER_TEST=mv $(CURDIR)/beancount_backup $(CURDIR)/beancount; rm -r {build_dir}/beancount/utils; cd {build_dir}/beancount/parser; rm lexer.l grammar.y parser.h parser.c

%:
	dh $@ --buildsystem pybuild

override_dh_python3:
	dh_python3 --recommends bottle --suggests google-api-python-client --suggests beautifulsoup4 --suggests requests

execute_after_dh_auto_build:
ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	cd $(CURDIR)/bin; \
	  for binary in *; do \
	    if [ "X$$binary" = "XBUILD" ]; then continue; fi ; \
	    PYTHONPATH=$$(cd $(CURDIR); pybuild --print build_dir --interpreter python3) \
	      help2man \
	        --name "$$(grep $$binary $(CURDIR)/debian/manpages/whatis.txt | cut -f 2)" \
	        --no-info \
	        --help-option=-h \
	        --version-string=$(DEB_VERSION_UPSTREAM) \
	        ./$$binary > $(CURDIR)/debian/manpages/$$binary.1 ; \
	  done
endif

execute_after_dh_auto_clean:
	rm -f debian/manpages/*.1

override_dh_installexamples:
	dh_installexamples -X __pycache__ -X .picklecache

## beancount 3.0.0

=== debian/changelog ===
beancount (3.0.0-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/patches/backport/:
    + 0004-lexer_test.py-Cherry-pick-from-trunk-for-Python3.13-.patch:
      Cherry-pick upstream latest version of lexer_test.py for Python
      3.13 compatibility.
  * debian/rules: Re-enable test_lex_indent.
  * debian/rules: Also strip the executable bits of installed .py files.

 -- Boyuan Yang <byang@debian.org>  Wed, 18 Dec 2024 15:33:05 -0500

beancount (3.0.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 3.0.0. (Closes: #1082361, #1086121)
  * debian/rules: Remove instructions on removed files:
    - sheets_upload.py
    - setup_test.py
  * debian/rules: Simplify instruction on pytest.
  * debian/rules: Skip some failing tests, need to look into them later.
  * debian/rules: Skip some help2man generation, need to look into them later.
  * debian/patches/: Drop patches no longer applicable.
    - 0001-Remove-fonts.googleapis.com-links: Dropped, no longer applicable.
    - Drop all backported patches.
    - backport/0004-Remove-cgi-module.patch: Drop usage of cgi module
      (Closes: #1084528)
  * debian/: Apply wrap-and-sort -abst.
  * debian/control: Move package description to source package section.
  * debian/control: Add new build-deps:
    + pybuild-plugin-pyproject, python3-mesonpy, python3-regex.
    + pkgconf.
    - python3-chardet.
  * debian/control: Manually add python3 dependencies due to automated
    dependency detection not processing optional plugin dependencies.

 -- Boyuan Yang <byang@debian.org>  Wed, 18 Dec 2024 12:44:01 -0500

beancount (2.3.6-2) unstable; urgency=medium

  * Team upload.
  * Remove Build-Depends on python3-oauth2client.
    Beancount 2.3.6-1 introduced a dependency on python3-oauth2client which
    has unfortunately been deprecated for 7 years now. Currently, beancount
    has been removed from testing due to two RC bugs in python3-oauth2client.
    The current use seems to be solely upload-to-sheets (calling
    sheets_upload.py). Note that in the recently-released beancount 3, this
    binary has been moved in another package.
    Thanks to Adrien Nader (Closes: #1076444)
  * Update Standards-Version to 4.7.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 05 Sep 2024 21:01:33 +0200

=== debian/control ===
Source: beancount
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Nicolas Dandrimont <olasd@debian.org>,
 Stefano Zacchiroli <zack@debian.org>,
Vcs-Browser: https://salsa.debian.org/python-team/packages/beancount
Vcs-Git: https://salsa.debian.org/python-team/packages/beancount.git
Homepage: https://github.com/beancount/
Standards-Version: 4.7.0
Section: utils
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 gnupg,
 help2man <!nodoc>,
 ledger,
 pkgconf,
 pybuild-plugin-pyproject,
 python3-all,
 python3-all-dev,
 python3-bottle,
 python3-bs4,
 python3-click (>= 7.0),
 python3-dateutil (>= 2.6.0),
 python3-google-auth-oauthlib,
 python3-googleapi,
 python3-lxml,
 python3-magic,
 python3-mesonpy,
 python3-pdfminer <!nocheck>,
 python3-ply,
 python3-pytest <!nocheck>,
 python3-regex,
 python3-requests,
 python3-setuptools,
Rules-Requires-Root: no
Description: Double-entry accounting from text files
 A double-entry bookkeeping computer language that lets you define financial
 transaction records in a text file, read them in memory, generate a variety of
 reports from them, and provides a web interface.
 .
 The following features require the following extra dependencies to be
 installed:
  - Beancount Web [python3-bottle]
  - OFX import [python3-bs4]
  - Google Sheets upload [python3-googleapi python3-google-auth-oauthlib]
  - External price imports [python3-requests]

Package: beancount
Architecture: all
Depends:
 python3,
 python3-beancount (<< ${source:Version}.1~),
 python3-beancount (>= ${source:Version}),
 ${misc:Depends},
Recommends:
 fava,
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: python3-beancount
Architecture: any
Section: python
Depends:
 python3-googleapi,
 python3-lxml,
 python3-magic,
 python3-ply,
 python3-requests,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 ${python3:Recommends},
Suggests:
 ${python3:Suggests},
Description: ${source:Synopsis} - Python module
 ${source:Extended-Description}
 .
 This package provides the underlying Python modules for beancount, allowing
 you to write your own scripts to manipulate your ledger files.

## beancount 3.1.0

=== debian/changelog ===
beancount (3.1.0-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/backport/: Backport upstream commits till 2025-01-23.

 -- Boyuan Yang <byang@debian.org>  Tue, 28 Jan 2025 10:58:27 -0500

beancount (3.1.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/patches: Refresh patches and drop backported patches.
  * debian/control: Add explicit build-dep to bison and flex.

 -- Boyuan Yang <byang@debian.org>  Tue, 28 Jan 2025 10:43:04 -0500

=== debian/control ===
--- 
+++ 
@@ -10,11 +10,14 @@
 Section: utils
 Priority: optional
 Build-Depends:
+ bison,
  debhelper-compat (= 13),
  dh-sequence-python3,
+ flex,
  gnupg,
  help2man <!nodoc>,
  ledger,
+ meson,
  pkgconf,
  pybuild-plugin-pyproject,
  python3-all,

## beancount 3.2.0

=== debian/changelog ===
beancount (3.2.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/patches/backport: Dropped.

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Sep 2025 13:05:41 -0400

beancount (3.1.0-3) unstable; urgency=medium

  * Team upload.
  * Rebuild the package with python3.13 only. (Closes: #1098533)

 -- Boyuan Yang <byang@debian.org>  Sat, 01 Mar 2025 19:42:32 -0500

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Vcs-Browser: https://salsa.debian.org/python-team/packages/beancount
 Vcs-Git: https://salsa.debian.org/python-team/packages/beancount.git
 Homepage: https://github.com/beancount/
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: utils
 Priority: optional
 Build-Depends:

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export PYBUILD_AFTER_BUILD=chmod +x {build_dir}/beancount/tools/treeify.py

# Failing tests, need to be solved later
export PYBUILD_TEST_ARGS=-v -k "not test_export_basic"
export PYBUILD_BEFORE_TEST=cp -r $(CURDIR)/beancount {build_dir}/beancount;
export PYBUILD_AFTER_TEST=:;

%:
	dh $@ --buildsystem pybuild

override_dh_python3:
	dh_python3 --recommends bottle --suggests google-api-python-client --suggests beautifulsoup4 --suggests requests

# Skip generation of specific tools for now, need to be solved later
execute_after_dh_auto_build:
ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	cd $(CURDIR)/bin; \
	  for binary in *; do \
	    if [ "X$$binary" = "XBUILD" ]; then continue; fi ; \
	    if [ "X$$binary" = "Xbean-check" ]; then continue; fi ; \
	    if [ "X$$binary" = "Xbean-doctor" ]; then continue; fi ; \
	    if [ "X$$binary" = "Xbean-example" ]; then continue; fi ; \
	    if [ "X$$binary" = "Xbean-format" ]; then continue; fi ; \
	    PYTHONPATH=$$(cd $(CURDIR); pybuild --print build_dir --interpreter python3) \
	      help2man \
	        --name "$$(grep $$binary $(CURDIR)/debian/manpages/whatis.txt | cut -f 2)" \
	        --no-info \
	        --help-option=-h \
	        --version-string=$(DEB_VERSION_UPSTREAM) \
	        ./$$binary > $(CURDIR)/debian/manpages/$$binary.1 ; \
	  done
endif

execute_after_dh_auto_clean:
	rm -f debian/manpages/*.1

override_dh_installexamples:
	dh_installexamples -X __pycache__ -X .picklecache

execute_after_dh_fixperms:
	find debian/*/usr/lib/python*/*-packages/beancount/* -type f -name '*.py' -exec chmod -x {} +

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/beancount-$1\.tar\.gz/ \
  https://github.com/beancount/beancount/tags .*/v?(\d\S+)\.tar\.gz
